;;;; -*- Mode: Lisp; Package: ASN.1; -*-

(in-package :asn.1)

(defun test (str)
  (display str))

(defun test-1 ()
  "Case-Sensitivity test"
  (test "Abc Def"))

(defun test-2 ()
  "Comment test"
  (list (test "asd--asdadsda
               asdasfd")
        (test "xxx /*asdkashfksjdf
                 sdfjkshdf*/ --yyy")
        (test "A -- B -- C")))

(defun test-3 ()
  "ASN.1 Number test"
  (list (test "'123'H")
        (test "'010100001'B")
        (test "'777'O")))

(defun test-4 ()
  "::="
  (test "Married ::= BOOLEAN"))

(defun test-5 ()
  "full test"
  (test "Type ::= SEQUENCE { component1 INTEGER,
                    component2 BOOLEAN,
                    ...,
                    [[ component3 REAL ]], -- version 2
                    ... }"))

(defun test-6 ()
  "full test with numbers"
  (test "counter Lottery-number ::= 45
sextuple Lottery-draw ::= { 7, 12, 23, 31, 33, 41 }
pair Coordinates ::= { x 5, y -3 }
choice Afters ::= dessert:\"profiterolles\""))

(defun test-7 ()
  (parse #p"ASN1:TEST;RECORD.ASN"))

(defun test-8 ()
  "XML tags"
  (test "<html>
          <head>XXX</head>
          <body/>
         </html>"))

(defun test-9 ()
  "MACRO test"
  (parse #p"ASN1:TEST;MACRO.ASN"))

(defun test-10 ()
  "MACRO test"
  (parse #p"ASN1:TEST;IMPORTS.ASN"))
